#include<bonnet.h>

int open(char *pathname, int flags, mode_t mode)
{
	inode_t ino;
	int ret;

	if(pathname == NULL)
		return 0;

	ino = namei(pathname);
	if(ino == 0)
		return 0;

	ft[next_ft_no].count = 1;
	ft[next_ft_no].offset = 0;
	ft[next_ft_no].ino = ino;
	ft[next_ft_no].flags = flags;
	ft[next_ft_no].mode = mode;
	ret = next_ft_no;

	while(next_ft_no++ < MAX_FD)
	{
		if(ft[next_ft_no].count == 0)
			break;
	}
	return ret;	
}

int creat(const char *pathname,mode_t mode)
{

}

int close(int filedes)
{
	if(ft[filedes].count == 1)
	{
		ft[filedes].count = 0;
		next_ft_no = filedes;		
		return 1;
	}
	else return 0;
}

#define DOWN_ALIGN(i) (i & 0xFFFFF000)
#define UP_ALIGN(i) DOWN_ALIGN(i) + BLKSIZE - 1

ssize_t read(int filedes, void *buffer, size_t n)
{
	ino_t ino;
	int offset;
	char *ptr;
	char *tmp;
	int i;

	if(filedes < 0)
		return 0;
	if(n < 0)
		return 0;

	tmp = new_balloc(1);
	ino = ft[filedes].ino;

	offset = ft[filedes].offset;

	/* check permition <- skip */

	for(i=DOWN_ALIGN(offset);i<=UP_ALIGN(offset+n);i+=BLKSIZE)
	{
		getblk(bmap(ino,i),tmp,1);
		ptr = tmp;

		if(offset > i)
		{
			ptr += offset;
			memcpy(buffer,ptr,BLKSIZE - offset);
			n-= BLKSIZE - offset;
		}
		else if(n > BLKSIZE)
		{
			memcpy(buffer,ptr,BLKSIZE);
			ptr += BLKSIZE;	
			n-= BLKSIZE;
		}
		else
			memcpy(buffer,ptr,n);
	}
}

ssize_t write(int filedes, const void *buffer, size_t n)
{
	
}

off_t lseek(int filedes, off_t offset, int start_flag)
{

}

int unlink(const char *pathname)
{

}

int remove(const char *pathname)
{

}

int fcntl(int filedes, int cmd, ...)
{

}
